;16bit AXY
;A: low word of target address
;X: bank byte of target address
;Y: requested size

!FX_COMMAND	= $21F0
!FX_SHIFT	= $21F1
!FX_DATA	= $21F2

FX_BufferData:
	PHP

	STA.l $4302		;target low 16bits from A
	TYA			;size from Y
	STA.l $4305	
	SEP #$20
	TXA
	STA.l $4304		;target bank from X
	
	LDA #$80		;1 reg, increment address
	STA.l $4300
	LDA.b #!FX_DATA		;$21F2
	STA.l $4301
	LDA #$01
	STA.l $420B

	PLP
	RTS

;-----

!VIDEO_OFFSET = 0

FX_Init:
	PHP
	SEP #$20

	LDA.b #!VIDEO_OFFSET>>24	;need to start the starting address of the video data (high byte first)
	STA.l !FX_SHIFT
	LDA.b #!VIDEO_OFFSET>>16
	STA.l !FX_SHIFT
	LDA.b #!VIDEO_OFFSET>>8
	STA.l !FX_SHIFT
	LDA.b #!VIDEO_OFFSET
	STA.l !FX_SHIFT
	LDA #$00	;set address
	STA.l !FX_COMMAND

-	LDA.l !FX_COMMAND	;must wait until port is ready
	BMI -

;insert audio setup here

	PLP
	RTS

;-----

!INTRO_TRACK	= 0
!IT_VOLUME	= 255

FX_SetupAudio:
	PHP
	SEP #$20

	LDA.b #!INTRO_TRACK>>8	;set audio track
	STA.l !FX_SHIFT
	LDA.b #!INTRO_TRACK
	STA.l !FX_SHIFT
	LDA #$01
	STA.l !FX_COMMAND

-	LDA.l !FX_COMMAND	;must wait
	AND #$40
	BNE -

	LDA.b #!IT_VOLUME	;set volume
	STA.l !FX_SHIFT
	STA.l !FX_SHIFT
	LDA #$02
	STA.l !FX_COMMAND

	PLP
	RTS

;-----

FX_PlayAudio:
	PHP
	SEP #$20

	LDA.l !FX_COMMAND	;only do this once
	AND #$20
	BNE .return

	LDA #$00		;start streaming
	STA.l !FX_SHIFT
	LDA #$03
	STA.l !FX_COMMAND

.return
	PLP
	RTS

;-----

FX_StopAudio:
	PHP
	SEP #$20

	LDA.l !FX_COMMAND	;don't pause if it's already paused
	AND #$20
	BEQ .return

	LDA #$02	;pause flag
	STA.l !FX_SHIFT
	LDA #$03
	STA.l !FX_COMMAND

.return
	PLP
	RTS

;-----

;8bit
;A: fadestep, 0-15
FX_FadeAudio:
	ASL #4		;volume is 0-255, scale value for this
	STA.l !FX_SHIFT
	STA.l !FX_SHIFT
	LDA #$02	;new volume
	STA.l !FX_COMMAND

	RTS