hirom

!irq_target	= $000505	;JML operand

;freespace notes:
;$1CE000-$1CFFFF appears to be free, 8KB is way more than required

;interrupt hooks
;===============

;c70004 jmp $0140     [c70140] A:3481 X:0040 Y:0164 S:06e1 D:0000 DB:00 NvMxdIzc V: 29 H: 240
;c70140 phb                    A:3481 X:0040 Y:0164 S:06e1 D:0000 DB:00 NvMxdIzc V: 29 H: 258
;c70141 phd                    A:3481 X:0040 Y:0164 S:06e0 D:0000 DB:00 NvMxdIzc V: 29 H: 278
;c70142 php                    A:3481 X:0040 Y:0164 S:06de D:0000 DB:00 NvMxdIzc V: 29 H: 306
;c70143 rep #$20               A:3481 X:0040 Y:0164 S:06dd D:0000 DB:00 NvMxdIzc V: 29 H: 326
;c70145 rep #$10               A:3481 X:0040 Y:0164 S:06dd D:0000 DB:00 NvmxdIzc V: 29 H: 344

org $C70140
	JML TestForIntro

;-----

org $1CE000|$C00000

!PARAMETER_X	= $0131
!PARAMETER_Y	= $0130

TestForIntro:
	PHB	;restored code
	PHD
	PHP

	REP #$30	;must test for the right parameters, do nothing if they don't match up
	CPX #!PARAMETER_X
	BNE .doNothing
	CPY #!PARAMETER_Y
	BNE .doNothing
	LDA $0021F0	;don't do anything if the device isn't even present (return 0000)
	BEQ .doNothing
;get ready to play video
	LDA #$0000
	TCD
	JSR SetupVideo
	JSR ShowVideo	;returns when it's finished either early by button press and such or if the video ran to finish
	JMP Restore	;game takes over from here

.doNothing
;return conditions: 16bit A
	REP #$20
	JML $C70145

;-----

SetupVideo:
	PHP
	SEP #$30
	STZ $4200
	SEI
	PHB
	LDA #$7F	;bank where video variables are
	PHA
	PLB

	JSR SetupIRQHandler
	JSR SetupVideoAll

	PLB
	PLP
	RTS

;-----

Restore:
	SEP #$20	;game takes over from here, show pendulum intro
	REP #$10
	STZ $4200	;no interrupts
	JML $C00057	;after it uploads the SPC driver, no earlier

;-----

SetupIRQHandler:
	PHP
	SEP #$30

	LDA.b #IRQ		;24bit operand of JML
	STA !irq_target
	LDA.b #IRQ>>8
	STA !irq_target+1
	LDA.b #IRQ>>16
	STA !irq_target+2

	PLP
	RTS

;-----

IRQ:
	REP #$30
	PHA
	PHX
	PHY
	PHD
	PHB
	LDA #$0000
	TCD

	JSR VideoIRQ

	REP #$30
	PLB
	PLD
	PLY
	PLX
	PLA
	RTI

;-----

;force color 0 some color, force screen on, no interrupts

TestHang:
	STZ $4200	;no more IRQ
	SEI
	LDX #$00
	STX $2121
	LDA #$AA
	SEP #$20
-	STA $2122
	INX
	BNE -
.hang
	LDA #$0F
	STA $2100
	BRA .hang

;-----

incsrc video15.asm
incsrc 21fx.asm

;internal header mods
;====================

;...